local M = {}
local defaultTorqueGraph = {}
local minTorqueGraph = {}
local maxTorqueGraph = {}
local torqueAmplifier = 5	
local Traquer = 0
function LCVS(f)
	local state = 1
	local r = function ()
		if state == 1 then state = 2 return "return {" end
		if state == 2 then
			local l = f:read()
			if l then return "{ "..l.." }," else state = 3 return "}" end
		end
		if state == 3 then return nil end
	end
	return assert(load(r))()
end

local function GTC()
	local FG = io.open("vehicles/v10_destroyer/lua/data/dynamic_torque.csv")
		local data = LCVS(FG)
	
	for i,graph in pairs(data) do
		if i == 1 then
			maxTorqueGraph = graph
		elseif i == 3 then
			minTorqueGraph = graph
		else
			defaultTorqueGraph = graph
		end
	end
end


local function CTC()	
	
	local NTC = {}
	for i,_ in pairs(defaultTorqueGraph) do
			NTC[i] = defaultTorqueGraph[i] + ((maxTorqueGraph[i] - defaultTorqueGraph[i]) * torqueAmplifier)
	end
	return NTC
end



local function STC()
	Airspeed = electrics.values.airspeed * 2.233333
	
	local engine = powertrain.getDevice("mainEngine")
	if engine.maxRPM == 8000 then
	 if Airspeed > 2000 then
	      if Airspeed >= Traquer + 100 then 
	          torqueAmplifier = torqueAmplifier + 4.5
		       -- SpeedModifier = 20
	           Traquer = Airspeed
	        end			
		  if not(electrics.values.throttle == 1) or electrics.values['rpm'] > 8100 or electrics.values['gear_M'] < -0.5 or (electrics.values['gear_M'] > -0.5 and electrics.values['gear_M'] < 0.5) then 
			  electrics.values.ActiveWheelControl = 0
			else
			  electrics.values.ActiveWheelControl = 10
			end			
	      if Airspeed <= Traquer - 100 then
	         torqueAmplifier = torqueAmplifier - 4.5
		     -- SpeedModifier = 10
	         Traquer = Airspeed
	        end
	    else
          if Airspeed >= Traquer + 50 then 
	         torqueAmplifier = torqueAmplifier + 2
		     -- SpeedModifier = 1
	         Traquer = Airspeed
	        end
			
		  if Airspeed > 2 then
		       if not(electrics.values.throttle == 1) or electrics.values['rpm'] > 8100 or electrics.values['gear_M'] < -0.5 or (electrics.values['gear_M'] > -0.5 and electrics.values['gear_M'] < 0.5) then 
			        electrics.values.ActiveWheelControl = 0
			    else
			        electrics.values.ActiveWheelControl = 3
			    end	
			end
		  
	      if Airspeed <= Traquer - 50 then
	         torqueAmplifier = torqueAmplifier - 2
		     -- SpeedModifier = 0
	         Traquer = Airspeed
	        end
	    end
	end
	
	if torqueAmplifier > 120 then torqueAmplifier = 120 end
	
	if electrics.values.throttle == 0 then electrics.values.ActiveWheelControl = 0 end

	if engine.maxRPM == 8000 then
	 NTC = CTC()
	

	 local ETL = engine.torqueCurve
	
	 for i, value in pairs(ETL) do
		 if i == 0 then
			
		    else
			   ETL[i] = NTC[i]
		    end
	    end
	    engine.torqueCurve = ETL
	end
end



local function onReset()
		torqueAmplifier = 5
		-- SpeedModifier = 100
		Traquer = 0
		electrics.values.ActiveWheelControl = 0
		GTC()
		STC()	
end

M.onReset   = onReset
M.updateGFX = STC

return M